(in-package :om)



(defun RT? (list)
"test si c'est une RT"
  (if
  (and (listp list) 
       (atom (car list))
       (listp (second list))
       (= 1 (length (cdr list))))
  list))



(defun double-grp (list)
  (if (and (rt? list) 
           (= 1 (length (cadr list)))
           (listp (cadr list))
           (rt? (caadr list)))
      (caadr list)))

(defmethod fixdbl-grp ((self list))
  "this fixes the terrible issue where we have a double group"
  (let* ((meas (cadr self))
         (measures (mapcar 'car meas))
         (cont (mapcar 'cadr meas))
         (fix (loop for i in cont
          collect (loop for s in i
                        collect (if (double-grp s) (double-grp s) s))))
         )
        (list '? (loop for tmsg in measures
               for s in fix
               collect (list tmsg s)))
    ))


(defmethod fixdbl-grp ((self voice))
  (let* ((tree (tree self))
         (chords (chords self))
         (tempo (tempo self)))
    (make-instance 'voice
                   :tree (fixdbl-grp tree)
                   :chords chords
                   :tempo tempo)))

